---------------------------------------- 
-- Menu Code --------------------------- 
----------------------------------------  

-- This is where the main menu is built.
-- You can specify a table with handlers
-- which reacts to click events.

----------------------------------------  
----------------------------------------  
----------------------------------------  

local Main = {
	{"File"      ,00000,00},
	{"Edit"      ,00000,00},
	{"Control"   ,00000,00},
	{"Help"      ,00000,00},
}

local File = {
	{"New"       ,00000,11},
	{"Open..."   ,00000,12},
--	{"Save"      ,00000,00},
--	{"Save As...",00000,00},
	{"Close"     ,00000,13},	
	{"Close All" ,00000,14},	
	{"-"         ,00000,00},
	{"Exit"      ,00000,15},
}

local Edit = {
	{"Cut"       ,16472,21},
	{"Copy"      ,16451,22},
	{"Paste"     ,16470,23},
	{"Delete"    ,00000,24},
	{"Select All",16449,25},
	{"-"         ,00000,00},
	{"Undo"      ,16474,26},
}

local Ctrl = {
	{"Start"     ,00120,31},
	{"Pause"     ,00000,32},
	{"Stop"      ,00000,33},
}

local Help = {
	{"About..."  ,00000,41},
}

local Close = {
	{"Close"     ,00000,13},	
	{"Close All" ,00000,14},	
}

----------------------------------------

local Handler
local function BuildMenu(parent,t)
	for k,v in pairs(t) do
		local m = Obj.Create("TMenuItem")
		m.Caption  = v[1]
		m.ShortCut = v[2]
		m.OnClick  = Handler[v[3]]
		parent.Add(m)
	end
end

----------------------------------------

local MenuObj
local MainMenu
function CreateMenu(form,tab,hnd)
	MenuObj  = Obj.Create("TMainMenu")
	MainMenu = MenuObj.Items
	Handler  = hnd
	BuildMenu(MainMenu           ,Main)
	BuildMenu(MainMenu.GetItem(0),File)
	BuildMenu(MainMenu.GetItem(1),Edit)
	BuildMenu(MainMenu.GetItem(2),Ctrl)
	BuildMenu(MainMenu.GetItem(3),Help)
	form.Menu = MenuObj

	TabPopup = Obj.Create("TPopupMenu")
	BuildMenu(TabPopup.Items,Close)
	tab.PopupMenu = TabPopup

	EditPopup = Obj.Create("TPopupMenu")
	BuildMenu(EditPopup.Items,Edit)
end

----------------------------------------

function FreeMenu()
	--...
	Obj.Free(EditPopup)
	Obj.Free(TabPopup)
	Obj.Free(MenuObj)
end
